diff --git a/drivers/net/wan/lmc/media.c b/drivers/net/wan/lmc/media.c
index 8e236b0..36b685f 100644
--- a/drivers/net/wan/lmc/media.c
+++ b/drivers/net/wan/lmc/media.c
@@ -85,63 +85,63 @@ static inline void write_av9110_bit(struct card *, int);
 static void write_av9110(struct card *, u32, u32, u32, u32, u32);
 
 struct media lmc_ds3_media = {
-	lmc_ds3_init,		/* special media init stuff */
-	lmc_ds3_default,	/* reset to default state */
-	lmc_ds3_set_status,	/* reset status to state provided */
-	lmc_dummy_set_1,	/* set clock source */
-	lmc_dummy_set2_1,	/* set line speed */
-	lmc_ds3_set_100ft,	/* set cable length */
-	lmc_ds3_set_scram,	/* set scrambler */
-	lmc_ds3_get_link_status, /* get link status */
-	lmc_dummy_set_1,	/* set link status */
-	lmc_ds3_set_crc_length,	/* set CRC length */
-	lmc_dummy_set_1,	/* set T1 or E1 circuit type */
-	lmc_ds3_watchdog
+	.init = lmc_ds3_init,
+	.defaults = lmc_ds3_default,
+	.set_status = lmc_ds3_set_status,
+	.set_clock_source = lmc_dummy_set_1,
+	.set_speed = lmc_dummy_set2_1,
+	.set_cable_length = lmc_ds3_set_100ft,
+	.set_scrambler = lmc_ds3_set_scram,
+	.get_link_status = lmc_ds3_get_link_status,
+	.set_link_status = lmc_dummy_set_1,
+	.set_crc_length = lmc_ds3_set_crc_length,
+	.set_circuit_type = lmc_dummy_set_1,
+	.watchdog = lmc_ds3_watchdog,
 };
 
 struct media lmc_hssi_media = {
-	lmc_hssi_init,		/* special media init stuff */
-	lmc_hssi_default,	/* reset to default state */
-	lmc_hssi_set_status,	/* reset status to state provided */
-	lmc_hssi_set_clock,	/* set clock source */
-	lmc_dummy_set2_1,	/* set line speed */
-	lmc_dummy_set_1,	/* set cable length */
-	lmc_dummy_set_1,	/* set scrambler */
-	lmc_hssi_get_link_status, /* get link status */
-	lmc_hssi_set_link_status, /* set link status */
-	lmc_hssi_set_crc_length, /* set CRC length */
-	lmc_dummy_set_1,	/* set T1 or E1 circuit type */
-	lmc_hssi_watchdog
+	.init = lmc_hssi_init,
+	.defaults = lmc_hssi_default,
+	.set_status = lmc_hssi_set_status,
+	.set_clock_source = lmc_hssi_set_clock,
+	.set_speed = lmc_dummy_set2_1,
+	.set_cable_length = lmc_dummy_set_1,
+	.set_scrambler = lmc_dummy_set_1,
+	.get_link_status = lmc_hssi_get_link_status,
+	.set_link_status = lmc_hssi_set_link_status,
+	.set_crc_length = lmc_hssi_set_crc_length,
+	.set_circuit_type = lmc_dummy_set_1,
+	.watchdog = lmc_hssi_watchdog,
 };
 
 struct media lmc_ssi_media = {
-	lmc_ssi_init,		/* special media init stuff */
-	lmc_ssi_default,	/* reset to default state */
-	lmc_ssi_set_status,	/* reset status to state provided */
-	lmc_ssi_set_clock,	/* set clock source */
-	lmc_ssi_set_speed,	/* set line speed */
-	lmc_dummy_set_1,	/* set cable length */
-	lmc_dummy_set_1,	/* set scrambler */
-	lmc_ssi_get_link_status, /* get link status */
-	lmc_ssi_set_link_status, /* set link status */
-	lmc_ssi_set_crc_length,	/* set CRC length */
-	lmc_dummy_set_1,	/* set T1 or E1 circuit type */
-	lmc_ssi_watchdog
+	.init = lmc_ssi_init,
+	.defaults = lmc_ssi_default,
+	.set_status = lmc_ssi_set_status,
+	.set_clock_source = lmc_ssi_set_clock,
+	.set_speed = lmc_ssi_set_speed,
+	.set_cable_length = lmc_dummy_set_1,
+	.set_scrambler = lmc_dummy_set_1,
+	.get_link_status = lmc_ssi_get_link_status,
+	.set_link_status = lmc_ssi_set_link_status,
+	.set_crc_length = lmc_ssi_set_crc_length,
+	.set_circuit_type = lmc_dummy_set_1,
+	.watchdog = lmc_ssi_watchdog,
 };
 
 struct media lmc_t1_media = {
-	lmc_t1_init,		/* special media init stuff */
-	lmc_t1_default,		/* reset to default state */
-	lmc_t1_set_status,	/* reset status to state provided */
-	lmc_t1_set_clock,	/* set clock source */
-	lmc_dummy_set2_1,	/* set line speed */
-	lmc_dummy_set_1,	/* set cable length */
-	lmc_dummy_set_1,	/* set scrambler */
-	lmc_t1_get_link_status,	/* get link status */
-	lmc_dummy_set_1,	/* set link status */
-	lmc_t1_set_crc_length,	/* set CRC length */
-	lmc_t1_set_circuit_type, /* set T1 or E1 circuit type */
-	lmc_t1_watchdog
+	.init = lmc_t1_init,
+	.defaults = lmc_t1_default,
+	.set_status = lmc_t1_set_status,
+	.set_clock_source = lmc_t1_set_clock,
+	.set_speed = lmc_dummy_set2_1,
+	.set_cable_length = lmc_dummy_set_1,
+	.set_scrambler = lmc_dummy_set_1,
+	.get_link_status = lmc_t1_get_link_status,
+	.set_link_status = lmc_dummy_set_1,
+	.set_crc_length = lmc_t1_set_crc_length,
+	.set_circuit_type = lmc_t1_set_circuit_type,
+	.watchdog = lmc_t1_watchdog,
 };
 
 static void lmc_dummy_set_1(struct card * const sc, int a)